package rocks.zipcode.quiz5.fundamentals;

import java.util.Arrays;

/**
 * @author leon on 21/12/2018.
 */
public class StringUtils {

    public static Character getMiddleCharacter(String string) {
        return string.charAt(string.length()/2);
    }

    public static String capitalizeMiddleCharacter(String str) {
        StringBuilder sb = new StringBuilder(str);
        sb.setCharAt(str.length()/2, Character.toUpperCase(getMiddleCharacter(str)));
        return sb.toString();
    }

    public static String lowerCaseMiddleCharacter(String str) {
        StringBuilder sb = new StringBuilder(str);
        sb.setCharAt(str.length()/2, Character.toLowerCase(getMiddleCharacter(str)));
        return sb.toString();    }

    public static Boolean isIsogram(String str) {
        // Convert the string in lower case letters
        str = str.toLowerCase();
        int len = str.length();

        char arr[] = str.toCharArray();

        Arrays.sort(arr);
        for (int i = 0; i < len - 1; i++) {
            if (arr[i] == arr[i + 1])
                return false;
        }
        return true;
    }

    public static Boolean hasDuplicateConsecutiveCharacters(String str) {
        for (int i = 0; i < (str.length() - 1); i++) {
            for (int j = i + 1; j < str.length(); j++) {
                if (str.charAt(i) == str.charAt(j)) {
                    return true;
                }
            }
        }
        return false;    }

    public static String removeConsecutiveDuplicateCharacters(String str) {
        Character dups = getDups(str);
        StringBuilder noDupes = new StringBuilder();
        for (int i = 0; i < str.length(); i++) {
            String si = str.substring(i, i + 1);
            if (str.charAt(i) != dups) {
                noDupes.append(str.charAt(i));
            }
        }
        return noDupes.toString();    }

    public static String invertCasing(String str) {
        char[] chars = str.toCharArray();
        for (int i = 0; i < chars.length; i++)
        {
            char c = chars[i];
            if (Character.isUpperCase(c))
            {
                chars[i] = Character.toLowerCase(c);
            }
            else if (Character.isLowerCase(c))
            {
                chars[i] = Character.toUpperCase(c);
            }
        }
        return new String(chars);    }

        public static Character getDups(String str){
            Character c = null;
            StringBuilder dups = new StringBuilder();
            for (int i = 0; i < (str.length() - 1); i++) {
                for (int j = i + 1; j < str.length(); j++) {
                    if (str.charAt(i) == str.charAt(j)) {
                        c = str.charAt(i);
                    }
                }
            }
            return c;
        }
}