package rocks.zipcode.quiz5.objectorientation.account;

/**
 * @author leon on 27/12/2018.
 */
public class BankAccount extends Account implements Transactable {

    private Double balance;

    public BankAccount(Double balance) {
        this.balance = balance;
    }

    public BankAccount() {
        balance = 0.0;
    }

    public void setBalance(Double val) {
        this.balance = val;
    }

    @Override
    public void deposit(Double amountToIncreaseBy) throws IllegalArgumentException {
        if(amountToIncreaseBy <= 0){
            throw new IllegalArgumentException();
        } else
            this.balance = balance + amountToIncreaseBy;
    }

    @Override
    public void withdrawal(Double amountToDecreaseBy) throws IllegalArgumentException {
        if (amountToDecreaseBy <= balance && amountToDecreaseBy > 0) {
            this.balance = balance - amountToDecreaseBy;
        } else if (amountToDecreaseBy <= balance && amountToDecreaseBy < 0) {
            this.balance = balance + amountToDecreaseBy;
            throw new IllegalArgumentException();
        }
    }

    @Override
    public Double getBalance() {
        return balance;
    }
}
